unit Unit1;

{$mode delphi}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls, StrUtils,
  OmniXML, OmniXMLUtils, Unit2;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Memo1:   TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  XML:      IXMLDocument;
  Children: IXMLNodeList;
  Node:     IXMLNode;
  Attribute: IXMLAttr;
begin
  //CREATE XML DOC
  XML := CreateXMLDoc('root', True);

  with XML.DocumentElement.AddChild('child') do
  begin
    Attributes['attribute1'] := 'value1';
  end;
  with XML.DocumentElement.AddChild('child') do
  begin
    Attributes['attribute2'] := 'value2';
  end;

  XML.SaveToFile('test1.xml');

  //READ XML DOC
  XML := CreateXMLDoc;

  Memo1.Clear;
  XML.LoadFromFile('test1.xml');
  Children := XML.DocumentElement.SelectNodes('child');
  for Node in Children do
    for Attribute in Node.Attributes do
      Memo1.Append(Node.NodeName + '[' + Attribute.NodeName + '] = ' + Attribute.NodeValue);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  XML:      IXMLDocument;
  Children: IXMLNodeList;
  I, L:     integer;
begin
  //CREATE XML DOC
  XML := CreateXMLDoc('root', True);

  with XML.DocumentElement.AddChild('child') do
  begin
    Attributes['attribute1'] := 'value1';
  end;
  with XML.DocumentElement.AddChild('child') do
  begin
    Attributes['attribute2'] := 'value2';
  end;
  XML.DocumentElement.AddChild('child').Attributes['attribute3'] := 'value3';
  XML.DocumentElement.AddChild('child').Attributes['attribute4'] := 'value4';

  XML.SaveToFile('test2.xml');

  //READ XML DOC
  XML := CreateXMLDoc;

  Memo1.Clear;
  Memo1.Lines.LoadFromFile('test2.xml');
  Memo1.Text := AnsiReplaceText(Memo1.Text, '>', '>' + #13 + #10);
  {XML.LoadFromFile('test2.xml');
  Children := XML.DocumentElement.SelectNodes('child');
  for I := 0 to Children.Count - 1 do
  begin
    for L := 0 to Children[I].Attributes.Count - 1 do
      Memo1.Append(Children[I].NodeName + '[' + Children[I].Attributes.Item[L].NodeName + '] = ' + Children[I].Attributes.Item[L].NodeValue);
  end;}
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  rootsXml: TRootsXml;
  row: TRow;
  i: integer;
begin
  rootsXml := TRootsXml.Create;
  try
    rootsXml.Ver      := 'version 27';
    rootsXml.RootFile := 'fred.exe';

    for i := 1 to 10 do
    begin
      row := rootsXml.Rows.Add;
      row.Id      := i;
      row.Name    := 'fred';
      row.Surname := 'Flintstone';
      row.Time    := 'late';
      row.Old     := 'very';
      row.Subject := 'Delphi';
    end;

    rootsXml.SaveToFile('test3.xml', ofIndent);
    Memo1.Clear;
    Memo1.Lines.LoadFromFile('test3.xml');
  finally
    rootsXml.free;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  XML:      IXMLDocument;
  Children: IXMLNodeList;
  Node:     IXMLNode;
  Attribute: IXMLAttr;
begin
  Memo1.Clear;
  XML := CreateXMLDoc;
  XML.LoadFromFile('test4.xml');
  Children := XML.DocumentElement.SelectNodes('RootItemReceipt');
  for Node in Children do
    for Attribute in Node.Attributes do
      Memo1.Append(Node.NodeName + '[' + Attribute.NodeName + '] = ' + Attribute.NodeValue);

  Children.Reset;
  Memo1.Append('');
  Memo1.Append('E4634 old value is ' + Children.FindNode('RootItemReceipt').Attributes.GetNamedItem('E4634').NodeValue);
  Children.FindNode('RootItemReceipt').SetAttribute('E4634', FloatToStr(123.45));
  Memo1.Append('E4634 new value is ' + Children.FindNode('RootItemReceipt').Attributes.GetNamedItem('E4634').NodeValue);
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  row  : IXMLNode;
  rowID: integer;
  xml  : IXMLDocument;
begin
  xml := ConstructXMLDocument('root');
  SetNodeAttr(xml.DocumentElement, 'ver', 'version 0.7.3');
  SetNodeAttr(xml.DocumentElement, 'file', 'MyApp.exe');
  for rowID := 1 to 5 do begin
    row := AppendNode(xml, 'row');
    SetNodeTextInt(row, 'id', rowID);
    SetNodeText(row, 'name', 'name' + IntToStr(rowID));
    SetNodeText(row, 'surname', 'surname' + IntToStr(rowID));
    SetNodeText(row, 'time', 'time' + IntToStr(rowID));
    SetNodeText(row, 'old', 'old' + IntToStr(rowID));
    SetNodeText(row, 'subject', 'subject' + IntToStr(rowID));
  end;
  XMLSaveToFile(xml, 'test5.xml', ofIndent);
  Memo1.Clear;
  Memo1.Lines.LoadFromFile('test5.xml');
end;

end.
